// --------------------------------------------------------------------
//  LongLong lib for BC++ 
//  unsigned longlong ͎bΉB
//  llong.h

#ifndef _LLONG_H_
#define _LLONG_H_

typedef __int64 llong ; // 

typedef union _LNGLONG_{
	llong        lx ; // hyper lx ;
	unsigned char cx[8] ;
	unsigned long l[2] ;
} LNGLONG ;

extern const unsigned char llongbit[64][20] ;

class longlong{
	private:
	  LNGLONG x ;
//	  double tmp ;
	  char bf[32] ; // ő20(܂)
	  unsigned char decimal_field[20] ;
	protected:
	  void strcopy(char *dst,char *src) ; // strcpygȂꍇłgl
	  int  strlength(char *str) ;// strlengȂꍇłgl
	  int  bit(int targetpos) ;
	  void decimal_field_add(unsigned char *add_field) ;
	  void decimal_field_string(int sign) ;
	  void llong_convert(int usign) ;
	  int  decode_decimal(char *decstr) ;
	  void llongdec_convert(char *decstr) ;
	  int  isdecimal(int c){
	    if(c>=0x30 && c<=0x39) return(1) ;
	    return(0) ;
	  } ;
	  int  ishexchar(int c){
	    c&=0x00ff ;
	    if(c>=0x30 && c<=0x39) return(1) ;
	    if(c>=0x41 && c<=0x46) return(1) ;
	    if(c>=0x61 && c<=0x66) return(1) ;
	    return(0) ;
	  } ;
	  int  hexint(int c){
	    c&=0x00ff ;
	    if(c>=0x30 && c<=0x39) return(c-0x30) ;
	    if(c>=0x41 && c<=0x46) return(c-0x37) ;
	    if(c>=0x61 && c<=0x66) return(c-0x57) ;
	    return(-1) ;
	  } ;
	  int  twohexint(char *xstr){
	    return( ((hexint(xstr[0]))<<4)+hexint(xstr[1]) ) ;
	  } ;
	  int inthex(int c){
	    if(c>=0 && c<=9) return(c+0x30) ;
	    else             return(c+0x37) ;
	  }
	  int tohexstr(char *dst,int hx,int addzero) ;
	public:
	  longlong(){ x.lx=0l ; } ;
	  longlong(llong z){ x.lx=z ; } ;
	  longlong(LNGLONG z){ x.lx=z.lx ; } ;
	  ~longlong(){} ;
	  llong val(void){ return(x.lx) ; }
	  void  val(llong v){ x.lx=v ; }
	  void  xval(char *xstr) ;
	  void  dval(char *dval){ llongdec_convert(dval) ; } ;
	  void add(llong z){ x.lx+=z ; } ;
	  void add(longlong zz) ;
	  void sub(llong z){ x.lx-=z ; } ;
	  void sub(longlong zz) ;
	  // \pT|[g
//	  char *lshort(void){ // double𒇉̂ŁA64bit̐x͖
//	    tmp=x.lx ; sprintf(bf,"%.0lf",tmp) ;
//	    return(bf) ;
//	  } // 폜
	  char *lldec(void){
	    llong_convert(0) ;
	    return(bf) ;
	  }
	  char *ulldec(void){
	    llong_convert(1) ;
	    return(bf) ;
	  }
	  char *llhex(void) ;
	  // \p擾Co邾Agp̎
//	  void lshort(char *gbf){
//	    lshort() ; strcopy(gbf,bf) ;
//	  } // 폜
	  void lldec(char *gbf){ lldec() ; strcopy(gbf,bf) ; }
	  void ulldec(char *gbf){ ulldec() ; strcopy(gbf,bf) ; }
	  void llhex(char *gbf){ llhex() ; strcopy(gbf,bf) ; }
	  void operator=(llong z){ val(z) ; }
	  void operator=(longlong zz) ;
	  void operator<=(char *xstr){ xval(xstr) ; } ;
	  void operator<<=(char *dstr){ dval(dstr) ; } ;
	  void operator+=(llong z){ add(z) ; }
	  void operator+=(longlong zz) ;
	  void operator-=(llong z){ sub(z) ; }
	  void operator-=(longlong zz) ;
	friend longlong operator+(longlong yy,longlong zz) ;
	friend longlong operator-(longlong yy,longlong zz) ;
	friend void operator<=(char *gbf,longlong zz) ;
	friend void operator<<=(char *gbf,longlong zz) ;
} ;

#endif

